open Match_unif
open Projet


type ident = Lexing.position * string

type tm = Tm of ident * (tm list)

type cond = Arrow of tm * tm | Darrow of tm * tm

type rule =
  | Rew of cond list * tm * tm
  | RelRew of cond list * tm * tm

type theory =
  | Builtin of ident * ident list
  | Equations of (tm * tm) list

type strategy =
  | Innermost
  | Outermost
  | ContextSensitive of (ident * (Lexing.position * int) list) list

type decl =
  | VarDecl of ident list
  | TheoryDecl of theory list
  | RulesDecl of rule list
  | StrategyDecl of strategy
  | OtherDecl of ident * string list
