(* Retirer les éléments redondants d'une liste (pour chaque élément de
   la liste, on garde son premier exemplaire; de plus, la liste est
   inversée) *)

let superfluous_list l =

  let rec rec_superfluous_list l acc = match l with
    | [] -> acc
    | t::q when not (List.mem t acc) -> rec_superfluous_list q (t::acc)
    | _::q -> rec_superfluous_list q acc in

  rec_superfluous_list l [];;


(* Maximum de deux entiers *)

let max a b = if a > b then a else b;;


(* Remplacement d'un élément dans une liste *)

let rec list_replace l i y =
  match l with
    | [] -> failwith ("L'indice "^(string_of_int i)^" dépasse de la liste.\n")
    | t::q -> match i with
        | 0 -> y::q
        | j -> t::(list_replace q (j-1) y);;


(* Si f : int -> 'a, list_of_fun f b e : 'a list est la liste des (f i)
   pour i compris entre b et e *)

let list_of_fun f b e =

  let rec rec_list_of_fun e acc =
    if b>e then
      acc
    else
      rec_list_of_fun (e-1) ((f e)::acc) in

  rec_list_of_fun e [];;


(* "Produit" de deux listes *)

let list_prod l1 l2 =

  let rec rec_list_prod p1 p2 acc =
    match (p1,p2) with
      | [],_ -> acc
      | t1::q1,[] -> rec_list_prod q1 l2 acc
      | t1::q1,t2::q2 -> rec_list_prod p1 q2 ((t1::t2)::acc) in

  rec_list_prod l1 l2 [];;
