open Match_unif
open Projet
open Printing


type test = {system: system; subst: int -> string option; name: string};;


(* Exemples tirés du polycopié du cours, version de décembre 2008. *)

(* Exemple 7.3 *)

let subst1 n =
  match n with
    | 0 -> Some "x"
    | 1 -> Some "y"
    | _ -> None;;

let system1 : system = [
  (
    Term("+",[Var 0; Term("0",[])]),
    Var 0
  );
  (
    Term("+",[Var 0;Term("S",[Var 1])]),
    Term("S",[Term("+",[Var 0;Var 1])])
  )
];;

let ex1 = {system=system1; subst=subst1; name="7.3"};;


(* Exemple 7.11 *)

let subst2 n =
  match n with
    | 0 -> Some "x"
    | 1 -> Some "y"
    | _ -> None;;

let system2 : system = [
  (
    Term("-",[Var 0;Term("0",[])]),
    Var 0
  );
  (
    Term("-",[Term("S",[Var 0]);Term("S",[Var 1])]),
    Term("-",[Var 0;Var 1])
  );
  (
    Term("/",[Term("0",[]);Term("S",[Var 1])]),
    Term("0",[])
  );
  (
    Term("/",[Term("S",[Var 0]);Term("S",[Var 1])]),
    Term("S",[Term("/",[Term("-",[Var 0;Var 1]);Term("S",[Var 1])])]);
  )
];;

let ex2 = {system=system2; subst=subst2; name="7.11"};;


(* Exemple 7.13 *)

let subst3 n =
  match n with
    | 0 -> Some "x"
    | _ -> None;;

let system3 : system = [
  (
    Term("f",[Term("f",[Var 0])]),
    Term("f",[Term("s",[Term("f",[Var 0])])])
  )
];;

let ex3 = {system=system3; subst=subst3; name="7.13"};;


(* Exemple 7.19 *)

let subst4 n =
  match n with
    | 0 -> Some "x"
    | 1 -> Some "y"
    | _ -> None;;

let system4 : system = [
  (
    Term("intlist",[Term("[]",[])]),
    Term("[]",[])
  );
  (
    Term("intlist",[Term(":",[Var 0;Var 1])]),
    Term(":",[Term("S",[Var 0]);Term("intlist",[Var 1])])
  );
  (
    Term("int",[Term("0",[]);Term("0",[])]),
    Term(":",[Term("0",[]);Term("[]",[])])
  );
  (
    Term("int",[Term("0",[]);Term("S",[Var 1])]),
    Term(":",[Term("0",[]);Term("int",[Term("S",[Term("0",[])]);Term("S",[Var 1])])])
  );
  (
    Term("int",[Term("S",[Var 0]);Term("0",[])]),
    Term("[]",[])
  );
  (
    Term("int",[Term("S",[Var 0]);Term("S",[Var 1])]),
    Term("intlist",[Term("int",[Var 0;Var 1])])
  )
];;

let ex4 = {system=system4; subst=subst4; name="7.19"};;


(* Exemple 6.12 *)

let subst5 n =
  match n with
    | 0 -> Some "x"
    | 1 -> Some "y"
    | 2 -> Some "z"
    | _ -> None;;

let system5 : system = [
  (
    Term(".",[Var 0;Term("e",[])]),
    Var 0
  );
  (
    Term(".",[Var 0;Term("I",[Var 0])]),
    Term("e",[])
  );
  (
    Term(".",[Term(".",[Var 0;Var 1]);Var 2]),
    Term(".",[Var 0;Term(".",[Var 1;Var 2])])
  )
];;

let ex5 = {system=system5; subst=subst5; name="6.12"};;


(* Exemple 7.25 *)

let subst9 n =
  match n with
    | 0 -> Some "x"
    | 1 -> Some "y"
    | _ -> None;;

let system9 : system = [
  (
    Term("f",[Term("0",[]);Term("1",[]);Var 0]),
    Term("f",[Var 0;Var 0;Var 0])
  );
  (
    Term("pi",[Var 0;Var 1]),
    Var 0
  );
  (
    Term("pi",[Var 0;Var 1]),
    Var 1
  )
];;

let ex9 = {system=system9; subst=subst9; name="7.25"};;


(* Exemples tirés du cours *)

(* Logique classique *)

let subst6 n =
  match n with
    | 0 -> Some "x"
    | 1 -> Some "y"
    | 2 -> Some "z"
    | _ -> None;;

let system6 : system = [
  (
    Term("not",[Term("not",[Var 0])]),
    Var 0
  );
  (
    Term("not",[Term("or",[Var 0;Var 1])]),
    Term("and",[Term("not",[Var 0]);Term("not",[Var 1])])
  );
  (
    Term("not",[Term("and",[Var 0;Var 1])]),
    Term("or",[Term("not",[Var 0]);Term("not",[Var 1])])
  );
  (
    Term("and",[Var 0;Term("or",[Var 1;Var 2])]),
    Term("or",[Term("and",[Var 0;Var 1]);Term("and",[Var 0;Var 2])])
  );
  (
    Term("and",[Term("or",[Var 1;Var 2]);Var 0]),
    Term("or",[Term("and",[Var 0;Var 1]);Term("and",[Var 0;Var 2])])
  )
];;

let ex6 = {system=system6; subst=subst6; name="logique"};;


(* Exemple classique *)

let subst7 n =
  match n with
    | 0 -> Some "x"
    | _ -> None;;

let system7 : system = [
  (
    Term("a",[Term("a",[Var 0])]),
    Term("b",[Term("c",[Var 0])])
  );
  (
    Term("b",[Term("b",[Var 0])]),
    Term("a",[Term("c",[Var 0])])
  );
  (
    Term("c",[Term("c",[Var 0])]),
    Term("a",[Term("b",[Var 0])])
  )
];;

let ex7 = {system=system7; subst=subst7; name="classique"};;


(* Entiers binaires *)
(* Ici, . désigne la concaténation, et # un équivalent de 0x pour les
   entiers hexadécimaux *)

let subst8 n =
  match n with
    | 0 -> Some "x"
    | 1 -> Some "y"
    | _ -> None;;

let system8 : system = [
  (
    Term("#",[Term("0",[])]),
    Term("0",[])
  );
  (
    Term("+",[Term(".",[Var 0;Term("0",[])]);Term(".",[Var 1;Term("0",[])])]),
    Term(".",[Term("+",[Var 0;Var 1]);Term("0",[])])
  );
  (
    Term("+",[Term(".",[Var 0;Term("1",[])]);Term(".",[Var 1;Term("0",[])])]),
    Term(".",[Term("+",[Var 0;Var 1]);Term("1",[])])
  );
  (
    Term("+",[Term(".",[Var 0;Term("0",[])]);Term(".",[Var 1;Term("1",[])])]),
    Term(".",[Term("+",[Var 0;Var 1]);Term("1",[])])
  );
  (
    Term("+",[Term(".",[Var 0;Term("1",[])]);Term(".",[Var 1;Term("1",[])])]),
    Term(".",[Term("+",[Term("+",[Var 0;Var 1]);Term("#",[Term("1",[])])]);Term("0",[])])
  );
];;

let ex8 = {system=system8; subst=subst8; name="binaire"};;


(* Test *)

let test (t:test) =
  let s = t.system
  and subst = t.subst
  and name = t.name in

  print_string ("\nExemple "^name^"\n");

  let def_symbs = compute_def_symbs s in
  let def_symbs_arit = compute_def_symbs_arit s in
  let symbs = compute_symbs s in
  let symbs_arit = compute_symbs_arit s in
  let const_symbs = compute_const_symbs s in
  let dps = compute_dps s in
  let g = compute_graph const_symbs dps in
  let scc = extract_components g in
  let rem = List.map (fun dep -> removable s [("+",0);("-",0);("/",0);(":",0);("S",0);("int",0);("intlist",0);("f",0);("0",0);("[]",0);("I",0);(".",0);("e",0);("not",0);("and",0);("or",0);("a",0);("b",0);("c",0);("#",0);("1",0);("pi",0)] dep) dps in
  let rem2 = List.map (fun dep -> removable s [("+",1);("-",1);("/",1);(":",1);("S",0);("int",1);("intlist",0);("f",0);("0",0);("[]",0);("I",0);(".",1);("e",0);("not",0);("and",1);("or",1);("a",0);("b",0);("c",0);("#",0);("1",0);("pi",1)] dep) dps in
  let proj = List.map (fun g ->
                         try
                           let (p,dep) = find_projection s g def_symbs_arit in
                           "("^(string_of_proj p)^","^(string_of_dp subst dep)^")"
                         with Not_found -> "Pas de projection trouvée"
                      ) scc in
  let sub_scc = main s in


  print_string "Ensemble des symboles définis.\n";
  print_string (string_of_list string_of_symb def_symbs "; ");
  print_newline();

  print_string "Ensemble des symboles définis avec arité.\n";
  print_string (string_of_list string_of_symb_arit def_symbs_arit "; ");
  print_newline();

  print_string "Ensemble des symboles.\n";
  print_string (string_of_list string_of_symb symbs "; ");
  print_newline();

  print_string "Ensemble des symboles avec arité.\n";
  print_string (string_of_list string_of_symb_arit symbs_arit "; ");
  print_newline();

  print_string "Ensemble des symboles constructeurs.\n";
  print_string (string_of_list string_of_symb const_symbs "; ");
  print_newline();

  print_string "Ensemble des paires de dépendance.\n";
  print_string (string_of_list (string_of_dp subst) dps ";\n");
  print_newline();

  print_string ("Création du fichier dep_graph."^name^".dot.\n");
  Graph.Pack.Digraph.dot_output g.graph ("dep_graph."^name^".dot");
  print_newline ();

  print_string ("Création des fichiers dep_scc."^name^".i.dot.\n");
  let i = ref (-1) in
  List.iter (fun x -> i := !i+1; Graph.Pack.Digraph.dot_output x.graph ("dep_scc."^name^"."^(string_of_int !i)^".dot")) scc;
  print_newline ();

  print_string "Paires de dépendances ôtables pour la première projection simple.\n";
  print_string (string_of_list string_of_can_be_removed rem "; ");
  print_newline ();

  print_string "Paires de dépendances ôtables pour la deuxième projection simple.\n";
  print_string (string_of_list string_of_can_be_removed rem2 "; ");
  print_newline ();

  print_string "Projection trouvée pour chaque composante fortement connexe.\n";
  print_string (string_of_list (fun s -> s) proj "; ");
  print_newline ();

  print_string ("Création des fichiers dep_scc_remaining."^name^".i.dot.\n");
  let i = ref (-1) in
  List.iter (fun x -> i := !i+1; Graph.Pack.Digraph.dot_output x.graph ("dep_scc_remaining."^name^"."^(string_of_int !i)^".dot")) sub_scc;
  print_newline ();;



let _ =
  test ex1;
  test ex2;
  test ex3;
  test ex4;
  test ex5;
  test ex6;
  test ex7;
  test ex8;
  test ex9;;
